<?php

namespace Modules\Lpj\Http\Controllers;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Modules\Lpj\Exports\LaporanPenilaianJaminanExport;
use Modules\Lpj\Models\Permohonan;
use Modules\Lpj\Models\Penilaian;
use Modules\Lpj\Models\PenawaranTender;
use Maatwebsite\Excel\Facades\Excel;
use Illuminate\Support\Facades\DB;

class LaporanPenilaianJaminanController extends Controller
{
    public $user;

    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        return view('lpj::laporan_penilaian_jaminan.index');
    }

    public function dataForDatatables(Request $request)
    {
        if (is_null($this->user) || !$this->user->can('laporan-admin-kredit.view')) {
            //abort(403, 'Sorry! You are not allowed to view laporan admin kredit.');
        }

        // Retrieve data from the database
        $query = Permohonan::query();
        $query = $query->where('status', 'done');

        // Apply search filter if provided
        if ($request->has('search') && !empty($request->get('search'))) {
            $search = json_decode($request->get('search'));


            if (!empty($search->start_date) || !empty($search->end_date)) {
                $startDate = $search->start_date ?? '1900-01-01';
                $endDate = $search->end_date ?? now()->toDateString();

                $query->where(function ($q) use ($startDate, $endDate) {
                    $q->whereHas('penilaian', function ($q2) use ($startDate, $endDate) {
                        $q2->whereBetween('tanggal_kunjungan', [$startDate, $endDate]);
                    })
                    ->orWhereHas('penawaran', function ($q3) use ($startDate, $endDate) {
                        $q3->whereBetween('tanggal_penilaian_sebelumnya', [$startDate, $endDate]);
                    });
                });
            }

            // Filter by branch if provided
            if (isset($search->branch_id) && !empty($search->branch_id)) {
                $query->where('branch_id', $search->branch_id);
            }

            if (isset($search->penilai_id) && !empty($search->penilai_id)) {
                $query->whereHas('penilaian._user_penilai.userPenilaiTeam', function ($q) use ($search) {
                    $q->where('user_id', $search->penilai_id);
                });
            }

            if (isset($search->search)) {

                $query->where(function ($q) use ($search) {
                    $q->where('nomor_registrasi', 'LIKE', '%' . $search->search . '%');
                    $q->orWhere('tanggal_permohonan', 'LIKE', '%' . $search->search . '%');
                    $q->orWhereRelation('user', 'name', 'LIKE', '%' . $search->search . '%');
                    $q->orWhereRelation('tujuanPenilaian', 'name', 'LIKE', '%' . $search->search . '%');
                    $q->orWhereRelation('branch', 'name', 'LIKE', '%' . $search->search . '%');
                     $q->orWhereRelation('debiture', DB::raw('LOWER(name)'), 'LIKE', '%' . strtolower($search->search) . '%');

                    $q->orWhereRelation('jenisFasilitasKredit', 'name', 'LIKE', '%' . $search->search . '%');
                    $q->orWhereRelation('jenisPenilaian', 'name', 'LIKE', '%' . $search->search . '%');
                    $q->orWhere('status', 'LIKE', '%' . $search->search . '%');
                });
            }
        }

        // Apply sorting if provided
        if ($request->has('sortOrder') && !empty($request->get('sortOrder'))) {
            $order  = $request->get('sortOrder');
            $column = $request->get('sortField');
            $query->orderBy($column, $order);
        }

        // Get the total count of records
        $totalRecords = $query->count();

        // Apply pagination if provided
        if ($request->has('page') && $request->has('size')) {
            $page   = $request->get('page');
            $size   = $request->get('size');
            $offset = ($page - 1) * $size; // Calculate the offset

            $query->skip($offset)->take($size);
        }

        // Get the filtered count of records
        $filteredRecords = $query->count();

        // Get the data for the current page
        $data = $query->with(['debiture.branch'])->get();

        $data = $data->map(function ($permohonan) {
            $luas_tanah    = 0;
            $luas_bangunan = 0;
            $nilai_tanah     = 0;
            $nilai_bangunan  = 0;
            $npw = 0;
            $nilai_liquidasi = 0;
            if (isset($permohonan->penilai->lpj)) {
                $lpj = json_decode($permohonan->penilai->lpj, true);
                $npw = str_replace('.', '', $lpj['total_nilai_pasar_wajar'] ?? 0);

                $luas_tanah    = $lpj['luas_tanah'] ?? 0;
                $luas_bangunan = $lpj['luas_bangunan'] ?? 0;
                // Calculate nilai_tanah dynamically by looking for all keys that start with 'nilai_tanah_'
                $nilai_tanah     = str_replace('.', '', $lpj['nilai_tanah_2'] ?? 0);

                $nilai_bangunan  = str_replace('.', '', $lpj['nilai_bangunan_2'] ?? 0);
                $nilai_liquidasi = str_replace('.', '', $lpj['likuidasi_nilai_2'] ?? 0);
            }

            return [
                'id'                => $permohonan->id,
                'nomor_registrasi'  => $permohonan->nomor_registrasi,
                'tanggal_permohonan' => $permohonan->tanggal_permohonan,
                'branch'            => $permohonan->debiture?->branch?->name,
                'name'              => $permohonan->debiture?->name,
                'pemohon'           => $permohonan->creator?->name,
                'tujuan_penilaian'  => $permohonan->tujuanPenilaian?->name,
                'jenis_agunan'      => $permohonan->documents?->pluck('jenisJaminan.name')->unique()->implode(', '),
                'alamat_agunan'     => $permohonan->documents?->map(function ($document) {
                    return formatAlamat($document);
                })->unique()->implode(', '),
                'luas_tanah'        => $luas_tanah . ' m²',
                'nilai_tanah'       => formatRupiah($nilai_tanah, 2),
                'luas_bangunan'     => $luas_bangunan . ' m²',
                'nilai_bangunan'    => formatRupiah($nilai_bangunan, 2),
                'tanggal_laporan'   => $permohonan->approval_dd_at ?? $permohonan->approval_eo_at ?? '',
                'tanggal_review'    => $permohonan->penilaian?->tanggal_kunjungan ?? '',
                'nilai_pasar_wajar' => formatRupiah($npw, 2),
                'nilai_likuidasi'   => formatRupiah($nilai_liquidasi, 2),
                'nama_penilai'      => $permohonan->penilaian?->_user_penilai?->userPenilaiTeam?->name,
            ];
        });

        // Calculate the page count
        $pageCount = ceil($totalRecords / $request->get('size'));

        // Calculate the current page number
        $currentPage = $request->get('page', 1);

        // Return the response data as a JSON object
        return response()->json([
            'draw'            => $request->get('draw'),
            'recordsTotal'    => $totalRecords,
            'recordsFiltered' => $filteredRecords,
            'pageCount'       => $pageCount,
            'page'            => $currentPage,
            'totalCount'      => $totalRecords,
            'data'            => $data,
        ]);
    }

    public function export(Request $request)
    {
        $startDate = $request->start_date;
        $endDate = $request->end_date;
        // name of the file
        $fileName = 'laporan_penilaian_jaminan_' . $startDate . '_' . $endDate . '.xlsx';
        return Excel::download(new LaporanPenilaianJaminanExport($request), $fileName);
    }


}
